//---------------------------------------------------------------------------

#ifndef __Scanner
#define __Scanner
#include "defs.hpp"
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include <system.hpp>

struct Lex {
LexWord l;
int beg, line;
int type;
Lex* prev, *next;
};

class TScanner {

protected:

void PutUK (int i);
int GetUK ();
Lex *Cur, *Head;
int beg;

public:

int CurLine, CurPos, TextLen;

__property int UK = { read = GetUK, write = PutUK }; //
__property Lex* CL = { read = Cur, write = Cur }; //. 
__property Lex* CHead = { read = Head, write = Head }; //. 
__property int lexbeg = { read = beg, write = beg }; // . 

void LogError(const AnsiString err, const AnsiString a, bool WantTerminate);
void TScanner::ShowError(const AnsiString err, const AnsiString wrong, bool WantTerminate);
int Scaner (LexWord l);
void Pass();
int GetData(const AnsiString FileName);
void AddLex(int Lexcode, LexWord l, int beg, int line);
int ReturnCur();
void* GetLex(int index);
void ClearLexList();
void ScanText();
TScanner(/*TStrings* NewLogList*/);  //   
~TScanner();

};
//---------------------------------------------------------------------------
#endif
